
#include <stdio.h>
#include <stdlib.h>

void __POKE__DiscardInit(float *probArray, unsigned *rcArray, unsigned functionCount)
{
  FILE *configFile = fopen("poke.config", "r");

  if (configFile) {
    unsigned index;
    unsigned returnCode;
    float    probability;

    while (fscanf(configFile, "%u %u %f", &index, &returnCode, &probability) != EOF) {
      if (index >= functionCount) {
        fprintf(stderr, "__POKE__ index %u out of bounds (>= %u)\n", index,
                functionCount);
        exit(-1);
      }

      probArray[index] = probability;
      rcArray[index]   = returnCode;
    }
  }
}

void __POKE__FuncDiscardInit(unsigned *rcArray, unsigned functionCount)
{
  FILE *configFile = fopen("poke.config", "r");
  char line[128];

  if (configFile) {
    unsigned index;
    unsigned returnCode;

    while (fgets(line, 128, configFile)) {
      if (sscanf(line, "fn_rc %u %u", &index, &returnCode)) {
        if (index >= functionCount) {
          fprintf(stderr, "__POKE__ index %u out of bounds (>= %u)\n", index,
                  functionCount);
          exit(-1);
        }

        rcArray[index] = returnCode;
      }
    }
  }
}


