
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include "rand.h"

void __POKE__ForkedInit(float *probArray, unsigned *countdownArray, unsigned numElements)
{
  FILE *configFile = fopen("poke.config", "r");
  char line[128];

  if (configFile) {
    unsigned  index;
    float     probability;

    while (fgets(line, 128, configFile)) {
      if (sscanf(line, "inst_rate %u %f", &index, &probability)) {
        if (index >= numElements) {
          fprintf(stderr, "__POKE__ index %u out of bounds (%u)\n", index, numElements);
          exit(-1);
        }
        
        if (probability > 0.0) {
          probArray[index] = probability;
          countdownArray[index] = __POKE__RandUIntExp(probability);
        }
      }
    }
  }
}



