
import os, sys, tempfile, re, subprocess, StringIO, shutil, signal, threading

import log



# TODO: right now this is a dumping ground for various classes and variables,
#       eventually things should be allocated to their own modules

# TODO: move this into separate .config file

#staticFailureRates  = ["0.01", "0.02", "0.04", "0.08", "0.16", "0.32", "0.64", "1.0"]
staticFailureRates  = ["0.01"]
#dynamicFailureRates = ["0.0000001", "0.000001", "0.00001", "0.0001", "0.001", "0.01", "0.1", "1.0"]
dynamicFailureRates = ["0.0000001", "0.000001", "0.00001", "0.0001", "0.001", "0.01"]


# TODO: add options to allow 'opt' and 'llc', etc to be specified



class PokeException(Exception):
    pass

def error(msg):
    sys.stderr.write("\n%s: ERROR: %s\n" % (sys.argv[0], msg))



def getAveMinMax(iterable):

  if not iterable:
    return None, None, None

  Ave = float(iterable[0])
  Min = Ave
  Max = Ave

  for i in iterable[1:]:
    if Max < i:
      Max = i;
    if Min > i:
      Min = i
    Ave += float(i)

  Ave /= len(iterable)

  return Ave, Min, Max


def parseNumbers(str):

  retList = []
  tokens = str.split(" ")

  for token in str.split(" "):
    parts = token.split("-")
    if len(parts) == 1:
      retList.append(int(parts[0]))
    elif len(parts) == 2:
      retList.extend(range(int(parts[0]), int(parts[1]) + 1))
    else:
      assert(0)

  return retList


# Temporary files and directories

class TempFile(object):

  def __init__(self):
    self.fhandle, self.fname = tempfile.mkstemp(prefix="poke.")

  def __del__(self):
    os.remove(self.fname)

class TempDir(object):

  def __init__(self):
    self.dname = tempfile.mkdtemp(prefix="poke.")

  def __del__(self):
    shutil.rmtree(self.dname)

temps = []
def tempFile():
  t = TempFile()
  temps.append(t)
  return t.fname

def tempDir():
  t = TempDir()
  temps.append(t)
  return t.dname



def findFirstMatch(file, regex):

    file = open(file, 'r')
    for line in file:

      hit = regex.match(line)
      if hit:
        return hit

    return None



def fractionToPercent(numerator, denominator):
    return (float(numerator) / float(denominator)) * 100.0


def copyPaths(paths, dir):
    log.writeHeader("copyPaths() to %s" % dir)

    for path in paths:

        if os.path.isfile(path):
            log.write("copying %s\n" % path)
            shutil.copy(path, dir)

        elif os.path.isdir(path):
            log.write("recursively copying %s\n" % path)
            dest = "%s/%s" % (dir, os.path.basename(path))
            if os.path.exists(dest):
                shutil.rmtree(dest)
            shutil.copytree(path, dest)

        else:
            assert 0, "path '%s' is not a path!" % path


def powerSet(list):
    yield []
    for i in range(len(list)):
        for subset in powerSet(list[i+1:]):
            yield [list[i]] + subset


def allTrue(func, seq):

    for elem in seq:
        if not func(elem):
            return False

    return True

def anyFalse(func, seq):

    for elem in seq:
        if not func(elem):
            return True

    return False






dirStack = []

# TODO: semantics not quite right

def pushd(dir=None):
    dirStack.append(os.getcwd())
    if dir:
        os.chdir(dir)

def popd():
    os.chdir(dirStack.pop())

def peekd():
    return dirStack[-1]


class BlankMap(dict):

    def __init__(self, *maps):
        self._maps = maps

    def __getitem__(self, key):
        for mapping in self._maps:
            try:
                return mapping[key]
            except KeyError:
                pass
        return ""

