
class FileWrapper(object):

  def __init__(self, iterable):
    self.iter = iter(iterable)
    self.step = None

  def advanceTo(self, *regexes):
    try:
      while True:
        self.next()
        for which, regex in enumerate(regexes):
          self.match = regex.search(self.step)
          if self.match:
            return which
    except StopIteration:
      return -1

  def __iter__(self):
    return self

  def next(self):
    self.step = self.iter.next()
    return self.step

