
import sys 


class Log(file):

  class Wrapper(object):

    def __init__(self, log, iterable):
      self.iter = iter(iterable)
      self.log  = log

    def __iter__(self):
      return self

    def next(self):
      x = self.iter.next()
      self.log.write(x)
      return x


  def __init__(self):
    pass

  def init(self, fileName):
    file.__init__(self, fileName, "w")

  def writeLine(self, text):
    self.write("%s\n" % text)

  def writeHeader(self, text):
    self.write("\nLOG >> %s\n" % text)
    self.write("%s\n" % ("-" * 60))
    self.flush()

  def warn(self, text):
    self.write("WARNING !! %s\n" % text)
    self.flush()

  def wrap(self, iterable):
    return self.Wrapper(self, iterable)

  def display(self, text):
    self.write(text)
    import sys
    sys.stdout.write(text)
    sys.stdout.flush()

  def displayLine(self, text=""):
    self.display("%s\n" % text)

sys.modules[__name__]=Log()



