
#include <stdio.h>
#include <stdlib.h>

#include "../../include/real/real.h"

#if defined(POKE_DISCARD)

unsigned accum(unsigned *arr) {

  unsigned i;
  REAL_ESCAPE_DECLARE(0, unsigned, sum, 0);

  for (i = 1000; i > 0; --i) {
    REAL_TRY(0) {
      REAL_ESCAPE_ASSIGN(0, unsigned, sum, sum + arr[i]);
    } REAL_CATCH(0) {
    } REAL_END(0);
  }

  return sum;
}

#elif defined(POKE_REUSE)

unsigned accum(unsigned *arr) {

  unsigned i;
  unsigned sum = 0;
  REAL_ESCAPE_DECLARE(0, unsigned, tmp, 1001);

  for (i = 1000; i > 0; --i) {
    REAL_TRY(0) {
      REAL_ESCAPE_ASSIGN(0, unsigned, tmp, arr[i]);
    } REAL_CATCH(0) {
    } REAL_END(0);
    sum += tmp;
  }

  return sum;
}

#else 

unsigned accum(unsigned *arr) {

  unsigned i;
  unsigned sum = 0;

  for (i = 1000; i > 0; --i) {
    sum += arr[i];
  }

  return sum;
}

#endif

int main(int argc, char **argv) {

  unsigned i;
  unsigned long long sum = 0;
  unsigned *arr = malloc(sizeof(unsigned) * 1001);

  for (i = 1000; i > 0; --i) {
    arr[i] = i;
  }

  for (i = 1000; i > 0; --i) {
    sum += accum(arr);
  }

  printf("Sum: %llu\n", sum);

  return 0;
}

