#!/usr/bin/env python

import sys, os

hasOverhead = int(sys.argv[1])

CPLMap = {
    "barneshut": 2.70,
    "bodytrack": 0.91,
    "canneal": 6.95,
    "ferret": 0.84,
    "kmeans": 0.50,
    "raytrace": 0.82,
    "x264": 0.30
    }          

FracMap = {
    "barneshut": 100.0,
    "bodytrack": 21.0,
    "canneal": 89.0,
    "ferret": 10.5,
    "kmeans": 84.0,
    "raytrace": 49.0,
    "x264": 42.0
    }

CoMap = {
    "barneshut": 0,
    "bodytrack": 76.0,
    "canneal": 100.0,
    "ferret": 100.0,
    "kmeans": 100.0,
    "raytrace": 96.0,
    "x264": 100.0
    }

FiMap = {
    "barneshut": 68.0,
    "bodytrack": 48.0,
    "canneal": 62.0,
    "ferret": 73.0,
    "kmeans": 66.0,
    "raytrace": 68.0,
    "x264": 76.0
    }

table = {}


if hasOverhead:
  files = ["overheadUC1", "overheadUC3"]
else:
  files = ["nooverheadUC2", "nooverheadUC4"]

for file in files:
  f = open(file)

  for line in f:
    app = line.split()[0]
    if app == "X":
      continue
    time = float(line.split()[1])
    if int(file[-1]) % 2 == 0:
      GranMap = FiMap
    else:
      GranMap = CoMap

    frac = (GranMap[app] * FracMap[app]) / 10000

    Variability = 100 * (((time * ((1 - frac) + frac * .81)) - 1) / 1)
    if Variability == -100.0:
      Variability = "N/A"
    else:
      Variability = -Variability

    Wearout = 100 * (((time * ((1 - frac) + frac / 1.1)) - 1) / 1)
    if Wearout == -100.0:
      Wearout = "N/A"
    else:
      Wearout = -Wearout

    DVFS = 100 * (((time * ((1 - frac) + frac * .49)) - 1) / 1)
    if DVFS == -100.0:
      DVFS = "N/A"
    else:
      DVFS = -DVFS

    Overclock = 100 * (((time * ((1 - frac) + frac / 1.3)) - 1) / 1)
    if Overclock == -100.0:
      Overclock = "N/A"
    else:
      Overclock = -Overclock

    row = table.setdefault(app, [])
    row.append((Variability, Wearout, DVFS, Overclock))

  f.close()



aveMap = 8 * [(0.0, 0)]

for app in sorted(table.keys()):

  print "%s &" % app

  for i, tuple in enumerate(table[app]):
    for j, item in enumerate(tuple):
      if item == "N/A":
        print "N/A",
      else:
        print "%.1f" % item,
        temp = aveMap[4*i + j]
        aveMap[4*i + j] = (temp[0] + item, temp[1] + 1)

      if i == 1 and j == 3:
        print "\\\\"
      else:
        print "&"

  #for tup in table[app]:
  #  if tup[0] == "N/A":
  #    print "N/A &"
  #  else:
  #    print "%.1f &" % tup[0] 

  #for tup in table[app]:
  #  if tup[1] == "N/A":
  #    print "N/A &"
  #  else:
  #    print "%.1f &" % tup[1] 

  #for tup in table[app]:
  #  if tup[2] == "N/A":
  #    print "N/A &"
  #  else:
  #    print "%.1f &" % tup[2] 

  #for index, tup in enumerate(table[app]):
  #  if tup[3] == "N/A":
  #    print "N/A",
  #  else:
  #    print "%.1f " % tup[3],

  #  if index == 1:
  #    print "\\\\"
  #  else:
  #    print "&"

print "\\hline"
print "\\textbf{average} &"

aveMap = [sum / num for sum, num in aveMap]
for i, item in enumerate(aveMap):
  print "%.1f" % item,
  if i == 7:
    print "\\\\"
  else:
    print "&"




