
function regression(app, instr, region, threads, rates, qualityString)

figure('visible', 'off')

legendArr = {};
for i = 1:length(rates)
  [fit, xData, yData] = getfit(app, instr, region, threads, rates{i}, qualityString);

  invRate = num2str(1/str2num(rates{i}));
  plot(xData, yData, getColor());
  legendArr = [legendArr {['rate 1/' invRate]}];
  hold on;
end

title(['quality vs. execution time for ' app ' ' instr ' ' region ' ' threads]);
xlabel('relative quality');
ylabel('relative instructions executed');
legend(legendArr, 'Location', 'EastOutside');

graphsDir = [pwd '/' qualityString '/graphs/eps/'];
mkdir(graphsDir);
f = [graphsDir app '_' instr '_' region '_t' threads '.fit.eps'];
print('-depsc', f);

