
function stats(app, instr, region, threads, rates, qualityString)

figure('visible', 'off')

legendArr = {};
for i = 1:length(rates)
  [fit{i}, xData{i}, yData{i}] = getfit(app, instr, region, threads, rates{i}, qualityString);
end

for i = 2:length(rates)
  xMin = max([min(xData{1}) min(xData{i})]);
  xMax = min([max(xData{1}) max(xData{i})]);

  left  = xData{1}(xData{1} >= xMin & xData{1} <= xMax);
  right = xData{i}(xData{i} >= xMin & xData{i} <= xMax);

  xRange = sort([left' right']);
  y1 = fnval(fit{1}, xRange)
  y2 = fnval(fit{i}, xRange)
  y = ((y2 - y1) ./ y1) * 100

  dataDir = [pwd '/' qualityString '/data/'];
  f = [dataDir app '_' instr '_' region '_t' threads '_r' rates{i} '.stats'];
  stats = [xRange' y'];
  save(f, 'stats', '-ascii');

  f = [dataDir app '_' instr '_' region '_t' threads '_r' rates{i} '.summary'];
  summary = [mean(y) std(y, 1)]';
  save(f, 'summary', '-ascii');
end

